#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum TimezoneSetting {
    #[serde(rename = "LOCAL")]
    Local,
    #[serde(rename = "UTC")]
    Utc,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl TimezoneSetting {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            TimezoneSetting::Local => "LOCAL",
            TimezoneSetting::Utc => "UTC",
            TimezoneSetting::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for TimezoneSetting {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for TimezoneSetting {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for TimezoneSetting {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<TimezoneSetting, conjure_object::plain::ParseEnumError> {
        match v {
            "LOCAL" => Ok(TimezoneSetting::Local),
            "UTC" => Ok(TimezoneSetting::Utc),
            v => v.parse().map(|v| TimezoneSetting::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for TimezoneSetting {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<TimezoneSetting, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the TimezoneSetting enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
